Telephone Linse(POJ-3662)

2024-06-17 23:18
文章标签 poj telephone 3662 linse

本文主要是介绍Telephone Linse(POJ-3662),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

Problem Description

Farmer John wants to set up a telephone line at his farm. Unfortunately, the phone company is uncooperative, so he needs to pay for some of the cables required to connect his farm to the phone system.

There are N (1 ≤ N ≤ 1,000) forlorn telephone poles conveniently numbered 1..N that are scattered around Farmer John's property; no cables connect any them. A total of P (1 ≤ P ≤ 10,000) pairs of poles can be connected by a cable; the rest are too far apart.
The i-th cable can connect the two distinct poles Ai and Bi, with length Li (1 ≤ Li ≤ 1,000,000) units if used. The input data set never names any {Ai, Bi} pair more than once. Pole 1 is already connected to the phone system, and pole N is at the farm. Poles 1 and N need to be connected by a path of cables; the rest of the poles might be used or might not be used.
As it turns out, the phone company is willing to provide Farmer John with K (0 ≤ K < N) lengths of cable for free. Beyond that he will have to pay a price equal to the length of the longest remaining cable he requires (each pair of poles is connected with a separate cable), or 0 if he does not need any additional cables.
Determine the minimum amount that Farmer John must pay.

Input

Line 1:Three space-separated integers: N, P, and K

Lines 2:P+1: Line i+1 contains the three space-separated integers: Ai, Bi, and Li

Output

Line 1: A single integer, the minimum amount Farmer John can pay. If it is impossible to connect the farm to the phone company, print -1.

Sample Input

5 7 1

1 2 5
3 1 4
2 4 8
3 2 3
5 2 9
3 4 7
4 5 6

Sample Output

4

题意:给出n个点,p条边,可以任选k条边免费。现在要使1到n连通,从1到n的路径上,在不免费的边中最大的长度的费用即支付费用,求最小费用。

思路

由于要求最小费用,所以让公司提供k根比较长的,剩下的由个人提供支付费用,然后从中挑出最长的L,也是说只要是长度比L长的且在这条路上用到的电缆,那么就应该由电信公司提供。 

对于每个方案,假设个人提供的最长电缆长度是L,从1到N找出一条路来,使这条路上的长度比L大的电缆的个数不超过k即可,然后求最短路。

对于所有方案,不断二分查找,使L尽可能的小。 

Source Program

#include<iostream>
#include<cstdio>
#include<cstring>
#include<cmath>
#include<algorithm>
#include<string>
#include<cstdlib>
#include<queue>
#include<vector>
#define INF 0x3f3f3f3f
#define PI acos(-1.0)
#define N 1001
#define MOD 2520
#define E 1e-12
using namespace std;
int n,p,k;
int x[N*10],y[N*10],w[N*10];
int head[N],tail;//添加方案时的指针
queue<int>Queue;//队列
int dis[N];//存储最短路路径
bool vis[N];//用于最短路路径判断
struct Node{int w;//节点的长度int pre;//结点的前驱int next;//结点的后继
}a[20005];
void addedge(int mid)
{tail=0;memset(head,-1,sizeof(head));for(int i=0;i<p;i++){/*添加从x到y*/if(w[i]>mid)a[tail].w=1;elsea[tail].w=0;a[tail].pre=y[i];a[tail].next=head[x[i]];head[x[i]]=tail;tail++;/*添加从y到x*/if(w[i]>mid)a[tail].w=1;elsea[tail].w=0;a[tail].pre=x[i];a[tail].next=head[y[i]];head[y[i]]=tail;tail++;}
}
int SPFA()
{memset(vis,0,sizeof(vis));memset(dis,INF,sizeof(dis));dis[1]=0;vis[1]=1;Queue.push(1);while(!Queue.empty()){int v=Queue.front();vis[v]=0;Queue.pop();for(int i=head[v];i!=-1;i=a[i].next){Node temp=a[i];if(dis[temp.pre]>dis[v]+temp.w){dis[temp.pre]=dis[v]+temp.w;if(vis[temp.pre]==0){Queue.push(temp.pre);vis[temp.pre]=1;}}}}return dis[n];
}int main()
{while(scanf("%d%d%d",&n,&p,&k)!=EOF){int maxx=-INF;for(int i=0;i<p;i++){scanf("%d%d%d",&x[i],&y[i],&w[i]);maxx=max(maxx,w[i]);//寻找最大长度}if(n==1)printf("0\n");else//二分查找最佳答案{int left=-1,right=maxx,mid;while(right-left>1){mid=(right+left)/2;addedge(mid);//将当前mid的值视为一种方案添加到队列中int minn=SPFA();if(minn==INF){right=-1;break;}else if(minn<=k)right=mid;elseleft=mid;}printf("%d\n",right);}}return 0;
}

 

这篇关于Telephone Linse(POJ-3662)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1070679

相关文章

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n

poj 1287 Networking(prim or kruscal最小生成树)

题意给你点与点间距离,求最小生成树。 注意点是,两点之间可能有不同的路,输入的时候选择最小的,和之前有道最短路WA的题目类似。 prim代码: #include<stdio.h>const int MaxN = 51;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int P;int prim(){bool vis[MaxN];

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D

poj 1502 MPI Maelstrom(单源最短路dijkstra)

题目真是长得头疼,好多生词,给跪。 没啥好说的,英语大水逼。 借助字典尝试翻译了一下,水逼直译求不喷 Description: BIT他们的超级计算机最近交货了。(定语秀了一堆词汇那就省略吧再见) Valentine McKee的研究顾问Jack Swigert,要她来测试一下这个系统。 Valentine告诉Swigert:“因为阿波罗是一个分布式共享内存的机器,所以它的内存访问

uva 10061 How many zero's and how many digits ?(不同进制阶乘末尾几个0)+poj 1401

题意是求在base进制下的 n!的结果有几位数,末尾有几个0。 想起刚开始的时候做的一道10进制下的n阶乘末尾有几个零,以及之前有做过的一道n阶乘的位数。 当时都是在10进制下的。 10进制下的做法是: 1. n阶位数:直接 lg(n!)就是得数的位数。 2. n阶末尾0的个数:由于2 * 5 将会在得数中以0的形式存在,所以计算2或者计算5,由于因子中出现5必然出现2,所以直接一

poj 3159 (spfa差分约束最短路) poj 1201

poj 3159: 题意: 每次给出b比a多不多于c个糖果,求n最多比1多多少个糖果。 解析: 差分约束。 这个博客讲差分约束讲的比较好: http://www.cnblogs.com/void/archive/2011/08/26/2153928.html 套个spfa。 代码: #include <iostream>#include <cstdio>#i